install.sh 8.4 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270
  1. #!/bin/sh
  2. # This script installs Ollama on Linux.
  3. # It detects the current operating system architecture and installs the appropriate version of Ollama.
  4. set -eu
  5. status() { echo ">>> $*" >&2; }
  6. error() { echo "ERROR $*"; exit 1; }
  7. warning() { echo "WARNING: $*"; }
  8. TEMP_DIR=$(mktemp -d)
  9. cleanup() { rm -rf $TEMP_DIR; }
  10. trap cleanup EXIT
  11. available() { command -v $1 >/dev/null; }
  12. require() {
  13. local MISSING=''
  14. for TOOL in $*; do
  15. if ! available $TOOL; then
  16. MISSING="$MISSING $TOOL"
  17. fi
  18. done
  19. echo $MISSING
  20. }
  21. [ "$(uname -s)" = "Linux" ] || error 'This script is intended to run on Linux only.'
  22. ARCH=$(uname -m)
  23. case "$ARCH" in
  24. x86_64) ARCH="amd64" ;;
  25. aarch64|arm64) ARCH="arm64" ;;
  26. *) error "Unsupported architecture: $ARCH" ;;
  27. esac
  28. KERN=$(uname -r)
  29. case "$KERN" in
  30. *icrosoft*WSL2 | *icrosoft*wsl2) ;;
  31. *icrosoft) error "Microsoft WSL1 is not currently supported. Please upgrade to WSL2 with 'wsl --set-version <distro> 2'" ;;
  32. *) ;;
  33. esac
  34. SUDO=
  35. if [ "$(id -u)" -ne 0 ]; then
  36. # Running as root, no need for sudo
  37. if ! available sudo; then
  38. error "This script requires superuser permissions. Please re-run as root."
  39. fi
  40. SUDO="sudo"
  41. fi
  42. NEEDS=$(require curl awk grep sed tee xargs)
  43. if [ -n "$NEEDS" ]; then
  44. status "ERROR: The following tools are required but missing:"
  45. for NEED in $NEEDS; do
  46. echo " - $NEED"
  47. done
  48. exit 1
  49. fi
  50. status "Downloading ollama..."
  51. curl --fail --show-error --location --progress-bar -o $TEMP_DIR/ollama "https://ollama.com/download/ollama-linux-$ARCH"
  52. for BINDIR in /usr/local/bin /usr/bin /bin; do
  53. echo $PATH | grep -q $BINDIR && break || continue
  54. done
  55. status "Installing ollama to $BINDIR..."
  56. $SUDO install -o0 -g0 -m755 -d $BINDIR
  57. $SUDO install -o0 -g0 -m755 $TEMP_DIR/ollama $BINDIR/ollama
  58. install_success() {
  59. status 'The Ollama API is now available at 127.0.0.1:11434.'
  60. status 'Install complete. Run "ollama" from the command line.'
  61. }
  62. trap install_success EXIT
  63. # Everything from this point onwards is optional.
  64. configure_systemd() {
  65. if ! id ollama >/dev/null 2>&1; then
  66. status "Creating ollama user..."
  67. $SUDO useradd -r -s /bin/false -m -d /usr/share/ollama ollama
  68. fi
  69. if getent group render >/dev/null 2>&1; then
  70. status "Adding ollama user to render group..."
  71. $SUDO usermod -a -G render ollama
  72. fi
  73. if getent group video >/dev/null 2>&1; then
  74. status "Adding ollama user to video group..."
  75. $SUDO usermod -a -G video ollama
  76. fi
  77. status "Adding current user to ollama group..."
  78. $SUDO usermod -a -G ollama $(whoami)
  79. status "Creating ollama systemd service..."
  80. cat <<EOF | $SUDO tee /etc/systemd/system/ollama.service >/dev/null
  81. [Unit]
  82. Description=Ollama Service
  83. After=network-online.target
  84. [Service]
  85. ExecStart=$BINDIR/ollama serve
  86. User=ollama
  87. Group=ollama
  88. Restart=always
  89. RestartSec=3
  90. Environment="PATH=$PATH"
  91. [Install]
  92. WantedBy=default.target
  93. EOF
  94. SYSTEMCTL_RUNNING="$(systemctl is-system-running || true)"
  95. case $SYSTEMCTL_RUNNING in
  96. running|degraded)
  97. status "Enabling and starting ollama service..."
  98. $SUDO systemctl daemon-reload
  99. $SUDO systemctl enable ollama
  100. start_service() { $SUDO systemctl restart ollama; }
  101. trap start_service EXIT
  102. ;;
  103. esac
  104. }
  105. if available systemctl; then
  106. configure_systemd
  107. fi
  108. if ! available lspci && ! available lshw; then
  109. warning "Unable to detect NVIDIA GPU. Install lspci or lshw to automatically detect and install NVIDIA CUDA drivers."
  110. exit 0
  111. fi
  112. check_gpu() {
  113. case $1 in
  114. lspci) available lspci && lspci -d '10de:' | grep -q 'NVIDIA' || return 1 ;;
  115. lshw) available lshw && $SUDO lshw -c display -numeric | grep -q 'vendor: .* \[10DE\]' || return 1 ;;
  116. nvidia-smi) available nvidia-smi || return 1 ;;
  117. esac
  118. }
  119. if check_gpu nvidia-smi; then
  120. status "NVIDIA GPU installed."
  121. exit 0
  122. fi
  123. if ! check_gpu lspci && ! check_gpu lshw; then
  124. install_success
  125. warning "No NVIDIA GPU detected. Ollama will run in CPU-only mode."
  126. exit 0
  127. fi
  128. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-7-centos-7
  129. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-8-rocky-8
  130. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#rhel-9-rocky-9
  131. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#fedora
  132. install_cuda_driver_yum() {
  133. status 'Installing NVIDIA repository...'
  134. case $PACKAGE_MANAGER in
  135. yum)
  136. $SUDO $PACKAGE_MANAGER -y install yum-utils
  137. $SUDO $PACKAGE_MANAGER-config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-$1$2.repo
  138. ;;
  139. dnf)
  140. $SUDO $PACKAGE_MANAGER config-manager --add-repo https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-$1$2.repo
  141. ;;
  142. esac
  143. case $1 in
  144. rhel)
  145. status 'Installing EPEL repository...'
  146. # EPEL is required for third-party dependencies such as dkms and libvdpau
  147. $SUDO $PACKAGE_MANAGER -y install https://dl.fedoraproject.org/pub/epel/epel-release-latest-$2.noarch.rpm || true
  148. ;;
  149. esac
  150. status 'Installing CUDA driver...'
  151. if [ "$1" = 'centos' ] || [ "$1$2" = 'rhel7' ]; then
  152. $SUDO $PACKAGE_MANAGER -y install nvidia-driver-latest-dkms
  153. fi
  154. $SUDO $PACKAGE_MANAGER -y install cuda-drivers
  155. }
  156. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#ubuntu
  157. # ref: https://docs.nvidia.com/cuda/cuda-installation-guide-linux/index.html#debian
  158. install_cuda_driver_apt() {
  159. status 'Installing NVIDIA repository...'
  160. curl -fsSL -o $TEMP_DIR/cuda-keyring.deb https://developer.download.nvidia.com/compute/cuda/repos/$1$2/$(uname -m)/cuda-keyring_1.1-1_all.deb
  161. case $1 in
  162. debian)
  163. status 'Enabling contrib sources...'
  164. $SUDO sed 's/main/contrib/' < /etc/apt/sources.list | $SUDO tee /etc/apt/sources.list.d/contrib.list > /dev/null
  165. if [ -f "/etc/apt/sources.list.d/debian.sources" ]; then
  166. $SUDO sed 's/main/contrib/' < /etc/apt/sources.list.d/debian.sources | $SUDO tee /etc/apt/sources.list.d/contrib.sources > /dev/null
  167. fi
  168. ;;
  169. esac
  170. status 'Installing CUDA driver...'
  171. $SUDO dpkg -i $TEMP_DIR/cuda-keyring.deb
  172. $SUDO apt-get update
  173. [ -n "$SUDO" ] && SUDO_E="$SUDO -E" || SUDO_E=
  174. DEBIAN_FRONTEND=noninteractive $SUDO_E apt-get -y install cuda-drivers -q
  175. }
  176. if [ ! -f "/etc/os-release" ]; then
  177. error "Unknown distribution. Skipping CUDA installation."
  178. fi
  179. . /etc/os-release
  180. OS_NAME=$ID
  181. OS_VERSION=$VERSION_ID
  182. PACKAGE_MANAGER=
  183. for PACKAGE_MANAGER in dnf yum apt-get; do
  184. if available $PACKAGE_MANAGER; then
  185. break
  186. fi
  187. done
  188. if [ -z "$PACKAGE_MANAGER" ]; then
  189. error "Unknown package manager. Skipping CUDA installation."
  190. fi
  191. if ! check_gpu nvidia-smi || [ -z "$(nvidia-smi | grep -o "CUDA Version: [0-9]*\.[0-9]*")" ]; then
  192. case $OS_NAME in
  193. centos|rhel) install_cuda_driver_yum 'rhel' $(echo $OS_VERSION | cut -d '.' -f 1) ;;
  194. rocky) install_cuda_driver_yum 'rhel' $(echo $OS_VERSION | cut -c1) ;;
  195. fedora) [ $OS_VERSION -lt '37' ] && install_cuda_driver_yum $OS_NAME $OS_VERSION || install_cuda_driver_yum $OS_NAME '37';;
  196. amzn) install_cuda_driver_yum 'fedora' '37' ;;
  197. debian) install_cuda_driver_apt $OS_NAME $OS_VERSION ;;
  198. ubuntu) install_cuda_driver_apt $OS_NAME $(echo $OS_VERSION | sed 's/\.//') ;;
  199. *) exit ;;
  200. esac
  201. fi
  202. if ! lsmod | grep -q nvidia; then
  203. KERNEL_RELEASE="$(uname -r)"
  204. case $OS_NAME in
  205. rocky) $SUDO $PACKAGE_MANAGER -y install kernel-devel kernel-headers ;;
  206. centos|rhel|amzn) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE kernel-headers-$KERNEL_RELEASE ;;
  207. fedora) $SUDO $PACKAGE_MANAGER -y install kernel-devel-$KERNEL_RELEASE ;;
  208. debian|ubuntu) $SUDO apt-get -y install linux-headers-$KERNEL_RELEASE ;;
  209. *) exit ;;
  210. esac
  211. NVIDIA_CUDA_VERSION=$($SUDO dkms status | awk -F: '/added/ { print $1 }')
  212. if [ -n "$NVIDIA_CUDA_VERSION" ]; then
  213. $SUDO dkms install $NVIDIA_CUDA_VERSION
  214. fi
  215. if lsmod | grep -q nouveau; then
  216. status 'Reboot to complete NVIDIA CUDA driver install.'
  217. exit 0
  218. fi
  219. $SUDO modprobe nvidia
  220. fi
  221. status "NVIDIA CUDA drivers installed."